Subject: RE: [Ips] Question about invalid PDUs and SCSI sense data

From: "John Hufferd" <[email-masked]>
Date: Tue, 16 Aug 2005 09:57:34 -0700

We neither allow nor disallow it.  It has no effect on interoperability
as long as the spec is followed by the target.  This is stuff that
developers all do when first developing code that will involve moving
from one level to another.  It is best that we continue our current
direction.  It hurts no one, and is useful to many.

.
.
.
John L Hufferd
Sr. Executive Director of Technology
Brocade Communications Systems, Inc
[email-masked]
Office Phone: (408) 333-5244; eFAX: (408) 904-4688
Alt Office Phone: (408) 997-6136; Cell: (408) 627-9606

-----Original Message-----
From: Eddy Quicksall [mailto:[email-masked]] 
Sent: Tuesday, August 16, 2005 5:19 AM
To: John Hufferd; [email-masked]; William Studenmund
Subject: Re: [Ips] Question about invalid PDUs and SCSI sense data

I didn't know we (the RFC) allowed for probing with invalid values.
Isn't 
that part of the reason the RFC has so many MUST's? Take the recent use
of 
0xFFFFFFFF for the ITT. It is now being made clear that the initiator
must 
not use that except for NOP's.

If probing with invalid values is allowed, it should be cleared up in 
draft-ietf-ips-iscsi-impl-guide-00.txt.

Eddy

----- Original Message ----- 
From: "John Hufferd" <[email-masked]>
To: "Eddy Quicksall" <[email-masked]>; 
<[email-masked]>; "William Studenmund" <[email-masked]>
Sent: Monday, August 15, 2005 5:28 PM
Subject: RE: [Ips] Question about invalid PDUs and SCSI sense data

I expect we should leave it up to the initiator, since they might be
probing the target with vendor specific items, which the target can not
handle, or early implementations of still un-standardized features. Not
that we should pre approve any of these, but we should just leave it as
it is, and let the initiator deal with it.

.
.
.
John L Hufferd
Sr. Executive Director of Technology
Brocade Communications Systems, Inc
[email-masked]
Office Phone: (408) 333-5244; eFAX: (408) 904-4688
Alt Office Phone: (408) 997-6136; Cell: (408) 627-9606

-----Original Message-----
From: [email-masked] [mailto:[email-masked]] On Behalf Of
Eddy Quicksall
Sent: Monday, August 15, 2005 1:21 PM
To: [email-masked]; William Studenmund
Subject: Re: [Ips] Question about invalid PDUs and SCSI sense data

BTW, I didn't mean to duck your original issue and that is "what sense
data
should be given for particular errors". I think there are people on the
reflector that are familiar with that issue so I will look forward to
those
responses.

Thanks,

Eddy

----- Original Message ----- 
From: "Paul Koning" <[email-masked]>
To: <[email-masked]>
Cc: <[email-masked]>
Sent: Monday, August 15, 2005 4:03 PM
Subject: Re: [Ips] Question about invalid PDUs and SCSI sense data

>>>>>> "Eddy" == Eddy Quicksall
<[email-masked]>
>>>>>> writes:
>
> >>> We already have examples in RFC 3720 where we report SCSI Sense
> >>> data in
> Eddy> response to iSCSI protocol confusion.
>
> Eddy> I've always wondered about these kind of examples. Exactly what
> Eddy> is the initiator supposed to do when it finds that the target
> Eddy> has reported a protocol error?
>
> Right.
>
> I can't see any sense in spending effort on complicated rules for
> protocol errors.  Just nuke the session and walk away.
>
> paul
>
>
> _______________________________________________
> Ips mailing list
> [email-masked]
> https://www1.ietf.org/mailman/listinfo/ips

_______________________________________________
Ips mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/ips

_______________________________________________
Ips mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/ips 

_______________________________________________
Ips mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/ips

---

From: "Eddy Quicksall" <[email-masked]>
Date: Tue, 16 Aug 2005 14:36:17 -0400

But the spec says:

6.6.  Format Errors

   The following two explicit violations of PDU layout rules are format
   errors:

      a)  Illegal contents of any PDU header field except the Opcode
          (legal values are specified in Section 10 iSCSI PDU Formats).
      b)  Inconsistent field contents (consistent field contents are
          specified in Section 10 iSCSI PDU Formats).

   Format errors indicate a major implementation flaw in one of the
   parties.

   When a target or an initiator receives an iSCSI PDU with a format
   error, it MUST immediately terminate all transport connections in the
   session either with a connection close or with a connection reset and
   escalate the format error to session recovery (see Section 6.1.4.4
   Session Recovery).

Eddy

----- Original Message ----- 
From: "John Hufferd" <[email-masked]>
To: "Eddy Quicksall" <[email-masked]>; 
<[email-masked]>; "William Studenmund" <[email-masked]>
Sent: Tuesday, August 16, 2005 12:57 PM
Subject: RE: [Ips] Question about invalid PDUs and SCSI sense data

.
.
.
John L Hufferd

-----Original Message-----
From: Eddy Quicksall [mailto:[email-masked]]
Sent: Tuesday, August 16, 2005 5:19 AM
To: John Hufferd; [email-masked]; William Studenmund
Subject: Re: [Ips] Question about invalid PDUs and SCSI sense data

Eddy

----- Original Message ----- 
From: "John Hufferd" <[email-masked]>
To: "Eddy Quicksall" <[email-masked]>;

.
.
.
John L Hufferd

-----Original Message-----

Thanks,

Eddy